<template>
  <div class="container" id="detail-table">
    <div class="total-number">{{ $t("message.statistics.totalNumber") }}:<span class="total-sum">{{Catalogues_Sum.toLocaleString('fi')}}</span></div>
    <table class="table table-hover table-responsive">
              <thead id="sticky"> <!-- v-sticky sticky-side="top" id="sticky" -->
                <tr>
                  <th v-on:click="sortTable(name)" class="table-img">
                    <span class="hide">{{name}} </span>
                    {{ $t("message.statistics.tableHead.category") }}
                  </th>
                  <th v-on:click="sortTable(name)" class="table-name">
                    <span class="hide">{{name}} </span>
                    <span :class="{ 'active': sortColumn === name }"> {{ $t("message.statistics.tableHead.name") }} </span>
                      &nbsp;
                      <span :class="{ 'up': sortColumn === name & ascending === true }"></span>
                      <span :class="{ 'down': sortColumn === name & ascending === false}"></span>
                  </th>
                  <th class="table-trend">
                    {{ $t("message.statistics.tableHead.trend") }}
                  </th>
                  <th v-on:click="sortTable(CountryCount)" class="table-percent">
                    <span class="hide">{{CountryCount}} </span>
                    <span :class="{ 'active': sortColumn === CountryCount }"> % </span>
                      &nbsp;
                      <span :class="{ 'up': sortColumn === CountryCount & ascending === true }"></span>
                      <span :class="{ 'down': sortColumn === CountryCount & ascending === false}"></span>
                  </th>
                  <th v-on:click="sortTable(CountryCount)" class="table-number">
                     <span class="hide">{{CountryCount}} </span>
                    {{ $t("message.statistics.tableHead.numberOfDatasets") }}
                  </th>
                  <!-- <th class="table-updated">
                    Updated
                  </th> -->
                </tr>
              </thead>
              <tbody>
              <div v-if="this.loading === true" class="lds-ring" id="spinner-overview"><div></div><div></div><div></div><div></div></div>
              <!-- eslint-disable-next-line  -->
                <tr v-for="(row, index) in Catalogues" :type="row.name" class="icon-change">
                   <td class="row-img">
                    <div v-if="row.name=='Economy and finance'" type="Economy and finance" class="flag-icon"></div>
                     <div v-else-if="row.name=='Environment'" type="Environment" class="flag-icon"></div>
                     <div v-else-if="row.name=='Regions and cities'" type="Regions and cities" class="flag-icon"></div>
                     <div v-else-if="row.name=='Population and society'" type="Population and society" class="flag-icon"></div>
                     <div v-else-if="row.name=='Education, culture and sport'" type="Education, culture and sport" class="flag-icon"></div>
                     <div v-else-if="row.name=='Health'" type="Health" class="flag-icon"></div>
                     <div v-else-if="row.name=='Science and technology'" type="Science and technology" class="flag-icon"></div>
                     <div v-else-if="row.name=='Transport'" type="Transport" class="flag-icon"></div>
                     <div v-else-if="row.name=='Agriculture, fisheries, forestry and food'" type="Agriculture, fisheries, forestry and food" class="flag-icon"></div>
                     <div v-else-if="row.name=='Justice, legal system and public safety'" type="Justice, legal system and public safety" class="flag-icon"></div>
                     <div v-else-if="row.name=='Energy'" type="Energy" class="flag-icon"></div>
                     <div v-else-if="row.name=='International issues'" type="International issues" class="flag-icon"></div>
                     <div v-else-if="row.name=='Government and public sector'" type="Government and public sector" class="flag-icon"></div>
                     <div v-else-if="row.name=='op: datpro'"></div>
                     <!-- <div v-else-if="row.name=='op: datpro'"> <img src="../assets/img/edplogo.png" width="30px" class="flag-icon"></div> -->
                    <div v-else>
                    <!-- <img src="../assets/img/edplogo.png" width="30px" class="flag-icon"> -->
                    </div>
                   </td>
                   <td class="row-name">
                     <div v-if="row.name=='op: datpro'"></div>
                     <div v-else>
                     {{row.name}}
                     </div>
                   </td>
                   <td class="row-trend">
                       <trend
                      :data = finalArray[index]
                      :gradient="['#20B2AA']"
                      auto-draw
                      smooth>
                      </trend>
                   </td>
                   <td class="row-percent">
                   <div v-if="row.name=='op: datpro'"></div>
                       <div v-else>
                     <span id="percent" v-if="round(100/(Catalogues_Sum/row.stats[row.stats.length-1].count),4) == 0">  {{round(100/(Catalogues_Sum/row.stats[row.stats.length-1].count),100)}}&nbsp;%   </span>
                     <span v-else>
                      <span id="percent">{{round(100/(Catalogues_Sum/row.stats[row.stats.length-1].count),4)}}&nbsp;% </span>
                      </span>
                     <div class="progress" style="height: 5px;">
                             <div class="progress-bar" role="progressbar" :style="'width:'+100/(Catalogues_Sum/row.stats[row.stats.length-1].count) +'%'"> </div>
                     </div>
                    </div>
                   <td class="row-number">
                      <div v-if="row.name=='op: datpro'"></div>
                     <div v-else>
                        {{row.stats[row.stats.length-1].count.toLocaleString('fi')}}
                     </div>
                   </td>
                   <!-- <td class="row-updated">
                     <div v-if="row.name=='op: datpro'"></div>
                     <div v-else>
                     {{row.stats[0].date}}
                     </div>
                   </td> -->
                </tr>
            </tbody>
    </table>
  </div>
</template>

<script>
/* eslint-disable */
import axios from 'axios'
import Vue from 'vue'
import Trend from 'vuetrend'


Vue.use(Trend)

export default {
  name: 'ChartContainer',
  data () {
    return {
      loaded: false,
      chartdata: [10, 20],
      Catalogues_Sum: '',
      Catalogues: [],
      loading: true,
      desc: ['yes', 'no', 'unknown'],
      data: [],
      showError: false,
      errorMessage: 'No Data availale.',
      name: 'name',
      CountryCount: 'CountryCount',
      ascending: true,
      sortColumn: 'name',
      isActive: false,
      isLoading: true,
      count_dummy: [],
      count_data_api: [],
      latest: 2,
      date_dummy: [],
      finalArray: [],
      hope: []
      }
  },
  mounted () {
    if (this.$route.params.package) {
      this.loading = true
      this.package = this.$route.params.package
    }
  },
  methods: {
    sortTable: function (x) {
      if (this.sortColumn === x) {
        this.ascending = !this.ascending
      } else {
        this.ascending = false
        this.sortColumn = x
      }
      var ascending = this.ascending
      this.Catalogues.sort(function (a, b) {
        if (a[x] > b[x]) {
          return ascending ? 1 : -1
        } else if (a[x] < b[x]) {
          return ascending ? -1 : 1
        }
        return 0
      })
    },
    sortTableStart: function (x) {
      if (this.sortColumn === x) {
        this.ascending = this.ascending
      } else {
        this.ascending = true
        this.sortColumn = x
      }
      var ascending = this.ascending
      this.Catalogues.sort(function (a, b) {
        if (a[x] > b[x]) {
          return ascending ? 1 : -1
        } else if (a[x] < b[x]) {
          return ascending ? -1 : 1
        }
        return 0
      })
    },
    addSortableCountryCount (arr) {
      for (var x = 0; x < arr.length; x++) {
        Vue.set(this.Catalogues[x], 'CountryCount', +this.Catalogues[x].stats[this.Catalogues[1].stats.length-1].count)
      }
      return arr
    },
    addLabels () {
      for (var i = 0; i < this.Catalogues.length; i++){
        for (var l = 0; l < this.Catalogues[i].stats.length; l++) {
            this.count_dummy.push(+this.Catalogues[i].stats[l].count)   //+ macht aus String zahl
        }
      }
      this.hope.push(this.count_dummy)
        for (i = 0; i < this.count_dummy.length ; i +=  this.Catalogues[0].stats.length) {
            this.finalArray.push(this.count_dummy.slice(i, i+this.Catalogues[0].stats.length));
      }
      for (var l = 0; l < this.Catalogues[0].stats.length; l++) {
        this.date_dummy.push(this.Catalogues[0].stats[l].date)
      }
    },
    addEvolutionCountryCount (arr, x) {
      for (var i = 0; i < arr.length; i++) {
      this.count_dummy.push(+this.Catalogues[x].stats[i].count)
      }
    },
    round (zahl, nStelle) {
      zahl = (Math.round(zahl * nStelle) / nStelle)
      return zahl
    },
    requestData () {
      axios.get(this.$env.ROOT_API + '/data/ds-per-category?list=true', { // http://odp-lic.ppe-aws.europeandataportal.eu:9090/data/ds-per-catalogue'
      })
        .then(response => {
          this.Catalogues = response.data.result
          this.Catalogues_Sum = response.data.sum
          this.loaded = true
          this.loading = false
          this.$emit('changeLoading', this.loading)
          this.sortTableStart(this.name)
          this.addSortableCountryCount(this.Catalogues)
          this.addLabels()
          // this.addEvolutionCountryCount(this.Catalogues, 0)
        })
        .catch(err => {
          this.errorMessage = err.response.data.error
          this.showError = true
        })
    },
    isMobile () {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true
      } else {
        return false
      }
    },
    isExplorer () {
      if (navigator.userAgent.indexOf('MSIE ') > -1 || navigator.userAgent.indexOf('Trident/') > -1 || window.navigator.userAgent.indexOf('Edge') > -1) {
        //  alert ('It is InternetExplorer')
        return true
      } else {
        //  alert('It is NOT InternetExplorer')
        return false
      }
    },
  },
  computed: {

  },
  Filters: {
    addPercentage: function (value) {
      return this.value + '%'
    },
  },
  created: function () {
    this.requestData()
  }
}
</script>

<style lang="scss">

.icon-change:hover > .row-img > .flag-icon {
  &[type="Economy and finance"] {
    background: url('../assets/img/categories/mouse_hover/economy.png') !important;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Environment"] {
    background: url('../assets/img/categories/mouse_hover/environment.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Regions and cities"] {
    background: url('../assets/img/categories/mouse_hover/regions.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Population and society"] {
    background: url('../assets/img/categories/mouse_hover/population.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Education, culture and sport"] {
    background: url('../assets/img/categories/mouse_hover/education.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Health"] {
    background: url('../assets/img/categories/mouse_hover/health.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Science and technology"] {
    background: url('../assets/img/categories/mouse_hover/science.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Transport"] {
    background: url('../assets/img/categories/mouse_hover/transport.png');
    background-size: cover;
    background-color: white !important;
    background-size: 35px !important;
    background-position: left -4px bottom 6px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Agriculture, fisheries, forestry and food"] {
    background: url('../assets/img/categories/mouse_hover/agriculture.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Justice, legal system and public safety"] {
    background: url('../assets/img/categories/mouse_hover/justice.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Energy"] {
    background: url('../assets/img/categories/mouse_hover/energy.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="International issues"] {
    background: url('../assets/img/categories/mouse_hover/international.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
  &[type="Government and public sector"] {
    background: url('../assets/img/categories/mouse_hover/government.png');
    background-size: cover;
    background-color: white !important;
    background-size: 45px !important;
    background-position: left -10px bottom 4px !important;
    background-repeat: no-repeat !important;
  }
}

.flag-icon{
  height: 25px;
  width: 25px;
  border-radius: 50%;
  margin-right: 14px;
  margin-left: 20px;
  background-color: white !important;
  background-size: 45px !important;
  background-position: left -10px bottom 4px !important;
  background-repeat: no-repeat !important;

  &[type="Economy and finance"] {
    background: url('../assets/img/categories/normal/economy.png');
  }
  &[type="Environment"] {
    background: url('../assets/img/categories/normal/environment.png');
  }
  &[type="Regions and cities"] {
    background: url('../assets/img/categories/normal/regions.png');
  }
  &[type="Population and society"] {
    background: url('../assets/img/categories/normal/population.png');
  }
  &[type="Education, culture and sport"] {
    background: url('../assets/img/categories/normal/education.png');
  }
  &[type="Health"] {
    background: url('../assets/img/categories/normal/health.png');
  }
  &[type="Science and technology"] {
    background: url('../assets/img/categories/normal/science.png');
  }
  &[type="Transport"] {
    background: url('../assets/img/categories/normal/transport.png');
    background-size: 35px !important;
    background-position: left -4px bottom 6px !important;
  }
  &[type="Agriculture, fisheries, forestry and food"] {
    background: url('../assets/img/categories/normal/agriculture.png');
  }
  &[type="Justice, legal system and public safety"] {
    background: url('../assets/img/categories/normal/justice.png');
  }
  &[type="Energy"] {
    background: url('../assets/img/categories/normal/energy.png');
  }
  &[type="International issues"] {
    background: url('../assets/img/categories/normal/international.png');
  }
  &[type="Government and public sector"] {
    background: url('../assets/img/categories/normal/government.png');
  }
}

#detail-table{
  margin-top:25px;
}

.total-number{
  padding-left: 5px;
  margin-bottom: 10px;
  float: right;
}

.total-sum{
  /**  rgba(181, 255, 250, 0.461); **/
  font-weight: 500;
  background-color: #cddbe8;
  padding: 5px;
  border-radius: 1.875rem;
  min-width: 100px;
  display: block;
  min-height: 33px;
}

.active-table-head{
  text-decoration:underline;
}

.active{
   text-decoration: none;
}
.down {
  border: solid black;
  border-width: 0 1px 1px 0;
  display: inline-block;
  padding: 2px;
  transform: rotate(45deg);
  -webkit-transform: rotate(45deg);
  margin-bottom:3px
}
.up {
  border: solid black;
  border-width: 0 1px 1px 0;
  display: inline-block;
  padding: 2px;
  transform: rotate(-135deg);
  -webkit-transform: rotate(-135deg);
  margin-bottom:1px
}

.table-img {
  cursor: pointer;
  text-align: left;
  width: 100px;
}
.table-name {
  cursor: pointer;
  text-align: left;
  width: 350px;
}
.table-trend {
  cursor: pointer;
  text-align: center;
  width: 150px;
  padding-right: 20px !important;
}
.table-percent {
  cursor: pointer;
  text-align: left;
  width: 160px;
}
.table-number {
  cursor: pointer;
  text-align: center;
  width: 150px;
}
.table-updated {
  cursor: pointer;
  text-align: left;
  width: 110px;
}

.row-img {
  text-align: left;
  width: 100px;
}
.row-name {
  text-align: left;
  width: 350px;
}
.row-trend {
  text-align: left;
  width: 150px;
  padding-right: 20px !important;
}
.row-percent {
  text-align: left;
  width: 160px;
}
.row-number {
  text-align: center;
  width: 150px;
}
.row-updated {
  text-align: left;
  width: 110px;
  font-size: 15px;
}

.hide{
  visibility: hidden;
  font-size: 0px;
}

  .progress-bar {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -ms-flex-direction: column;
    flex-direction: column;
    -webkit-box-pack: center;
    -ms-flex-pack: center;
    justify-content: center;
    color: #fff;
    text-align: center;
    white-space: nowrap;
    background-color: #3B6AA0;
    -webkit-transition: width 0.6s ease;
    transition: width 0.6s ease;
}

 #percent {
    text-align: center;
    color: #000;
    margin-right: 135px;
    font-size: 16px;
  }

  #less{
    font-size: 12px;
    color: darkgrey;
  }

  #sticky {
  background-color: #fff !important;
  background: solid;
  min-width: 952px !important;
}

</style>
